/*
 * adc.h
 *
 * Created: 19/07/2023 15:33:39
 *  Author: Simon 
 */ 


#ifndef ADC_HAL_H_
#define ADC_HAL_H_

extern volatile uint16_t adc_result[2][12] ; // This array will hold the slots results

typedef enum 
{
	ADC_SF_1MHz = 0x0 ,
	ADC_SF_500kHz = 0x1 ,
	ADC_SF_250kHz = 0x2 ,
	ADC_SF_125kHz = 0x3 ,
	ADC_SF_62kHz = 0x4 ,
	ADC_SF_31kHz = 0x5 ,
	ADC_SF_15kHz = 0x6 ,
	ADC_SF_8kHz = 0x7 
		
} ADC_SF_t ; // this is rounded raw sample rate before filtering or oversampling
	
typedef enum
{
	ADC_CH0 = (0x1 << 0) ,
	ADC_CH1 = (0x1 << 1) ,
	ADC_CH2 = (0x1 << 2) ,
	ADC_CH3 = (0x1 << 3) ,
	ADC_CH4 = (0x1 << 4) ,
	ADC_CH5 = (0x1 << 5) ,
	ADC_CH6 = (0x1 << 6) ,
	ADC_CH7 = (0x1 << 7) ,
	ADC_CH8 = (0x1 << 8) ,
	ADC_CH9 = (0x1 << 9) ,
	ADC_CH10 = (0x1 << 10) ,
	ADC_CH11 = (0x1 << 11) 
	
} ADC_CH_t ;

typedef enum
{
	adc_resolution_12_fast = 0 ,
	adc_resolution_12_filtered_1024 = 0xA ,
	adc_resolution_16_fast = 0xB ,
	adc_resolution_16_filtered_4 = 0xE 
	
} adc_resolution_t;


extern void adc_setup_enable_rr(Adc * instance, ADC_SF_t prescaler, ADC_CH_t channels , adc_resolution_t resolution) ;
// resolution to be 12-16, channel numbers to be ORed together in function call.

extern void add_adc_channel(Adc * instance , ADC_CH_t channel ) ;

extern void ADC_rr_handler(Adc * instance) ; // 


#endif /* ADC_HAL_H_ */