/*
 * clock.h
 *
 * Created: 16/06/2023 09:01:12
 *  Author: Simon
 */ 


#ifndef CLOCK_H_
#define CLOCK_H_

#include "samc21.h"

typedef enum 
	{
	EIC_GCLK = 2 ,
	EVSYS_CH0_GCLK = 6 ,
	EVSYS_CH1_GCLK = 7 ,
	EVSYS_CH2_GCLK = 8 ,
	EVSYS_CH3_GCLK = 9 ,
	EVSYS_CH4_GCLK = 10 ,
	EVSYS_CH5_GCLK = 11 ,
	EVSYS_CH6_GCLK = 12 ,
	EVSYS_CH7_GCLK = 13 ,
	EVSYS_CH8_GCLK = 14 ,
	EVSYS_CH9_GCLK = 15 ,
	EVSYS_CH10_GCLK = 16 ,
	EVSYS_CH11_GCLK = 17 ,
	SERCOM0_GCLK = 19 ,
	SERCOM1_GCLK = 20,
	SERCOM2_GCLK = 21 ,
	SERCOM3_GCLK = 22 ,
	SERCOM4_GCLK = 23 ,
	SERCOM5_GCLK = 25 ,
	SERCOM_SLOW_GCLK = 24 ,
	CAN0_GCLK = 26 ,
	CAN1_GLCK = 27 ,
	TCC0_TCC1_GCLK = 28 ,
	TCC2_GCLK = 29 ,
	TC0_TC1_GCLK = 30 ,
	TC2_TC3_GCLK = 31 ,
	TC4_GCLK = 32 ,
	ADC0_GCLK = 33 ,
	ADC1_GCLK = 34 ,
	SDADC_GCLK = 35 ,
	DAC_GCLK = 36 ,
	CCL_GCLK = 38 ,
	AC_GCLK = 40 
	
} peripheral_clock_channel_t ;

typedef enum {
	GCLK0 = 0 ,
	GCLK1 = 1 ,
	GCLK2 = 2 ,
	GCLK3 = 3 ,
	GCLK4 = 4 ,
	GCLK5 = 5 ,
	GCLK6 = 6 ,
	GCLK7 = 7
	
} gclk_t ;

typedef enum
	{
	F_48MHz = 0x0 ,
	F_32MHz = 0x1 ,
	F_96MHz = 0x2 ,
	F_32kHz = 0x3 ,
	F_2400kHz = 0x4 ,
	
} clock_source_t ;

void connect_peripheral_to_clock(peripheral_clock_channel_t peripheral, clock_source_t gclk_channel) ;

void clock_setup () ;




#endif /* CLOCK_H_ */