/*
 * SAMC21J starter project.c
 *
 * Created: 16/06/2023 08:59:41
 * Author : Simon
 */ 


#include "samc21.h"
#include "clock.h"
#include "rtc.h"
#include "nvic_hal.h"
#include "eic.h"
#include "adc_hal.h"
#include "tc_hal.h"


int main(void)
{	
    clock_setup();
	
	//********************************************* Application setup code, DO NOT put any code above ******************************************
	
	// ************************************************ digital output setup example
	
	pin_mode(PB06, Digital_output) ;
	
	
	//************************************************** TC PWM setup example *********************************************************
	
	connect_peripheral_to_clock(TC0_TC1_GCLK , F_32kHz) ;
	tc_pwm_setup_enable(TC0, 10, tc_prescaler_1) ; // connect counter to clock first
	tc_pwm_duty_update(TC0, tc_ch1, 20) ;
	pin_mode(PB09, TC_pin) ;	
	
	/******************************************************** ADC setup example ************************************************************
	
	adc_setup_enable_rr(ADC0, ADC_SF_1MHz, ADC_CH0 , adc_resolution_16_filtered_4) ;
	add_adc_channel(ADC0 , ADC_CH2 ) ;
	*/
	
	//******************************************************* DO NOT put any code below before the while loop call*************************
	
	systick_setup_enable() ; // this runs time intervals of 100ms.
	rtc_setup_enable() ; // this runs all time intervals to 32ms 2.34% faster than suggested by the names and all time intervals over 100ms with crystal accuracy
	
    /* application code */
    while (1) 
    {		
		pin_toggle(PB06) ;
		// *************************************************************** 250 s ********************************************************

		if (rtc_return_250us_tick()) // 250 s
		{
			
		} // end 250s

		// **************************************************************** 500 s ***********************************************************

		if (rtc_return_500us_tick()) // 500 s
		{
			
		} // end 500 s

		// ***************************************************************** 1 ms ***********************************************************

		if (rtc_return_1ms_tick()) // 1 ms
		{
			
		} // end 1 ms

		// ********************************************************************* 1 ms **************************************************

		if (rtc_return_2ms_tick()) // 2 ms
		{
			
		} // end 2ms

		// ******************************************************************** 4 ms *********************************************************

		if (rtc_return_4ms_tick()) // 4ms
		{
			
		} // end 4 ms

		// ******************************************************************** 8 ms ******************************************************

		if (rtc_return_8ms_tick()) // 8 ms
		{
			
		} // end 8 ms

		// ************************************************************ ****** 16 ms ****************************************************************

		if (rtc_return_16ms_tick()) // 16 ms
		{
			
			
		} // end 16 ms

		// ******************************************************************* 32 ms *****************************************************************

		if (rtc_return_32ms_tick()) // 32 ms
		{
			
		} // end 32 ms
		
		// ****************************************************************** 100 ms ***************************************************************
		
		if (systick_return_100ms_tick()) // 100 ms
		{
			
		} // end 100ms
		
		// ******************************************************************* 250 ms *****************************************************************

		if (rtc_return_250ms_tick()) // 250 ms
		{
			
		} // end 250 ms
		
		// ******************************************************************* 500 ms *****************************************************************

		if (rtc_return_500ms_tick()) // 500 ms
		{
			
		} // end 500 ms

		// ******************************************************************* 1 s *****************************************************************

		if (rtc_return_1s_tick()) // 1 s
		{			
			
		} // end 1 s
		
		
    } // end of main program while loop
} // end of main()

/**********************************************************************************************************************************************/
/*                                                                                                                                            */
/*                                                               INTERRUPT HANDLERS                                                           */
/*                                                                                                                                            */
/**********************************************************************************************************************************************/

void ADC0_Handler()
{
	ADC_rr_handler(ADC0) ;
}

void ADC1_Handler()
{
	ADC_rr_handler(ADC1) ;
}

void EIC_Handler()
{
	/********************************************************************** EIC ch 0 int handler **********************************************/

	if (EIC->INTFLAG.reg & 0x1 << 0)
	{
		EIC->INTFLAG.reg = 0x1 << 0 ;
	}

	/*********************************************************************** EIC ch 1 int handler **********************************************/

	if (EIC->INTFLAG.reg & 0x1 << 1)
	{
		EIC->INTFLAG.reg = 0x1 << 1 ;
	}

	/*********************************************************************** EIC ch 2 int handler ***********************************************/

	if (EIC->INTFLAG.reg & 0x1 << 2)
	{
		EIC->INTFLAG.reg = 0x1 << 2 ;
	}

	/*********************************************************************** EIC ch 3 int handler ************************************************/

	if (EIC->INTFLAG.reg & 0x1 << 3)
	{
		EIC->INTFLAG.reg = 0x1 << 3 ;
	}

	/*********************************************************************** EIC ch 4 int handler ************************************************/

	if (EIC->INTFLAG.reg & 0x1 << 4)
	{
		EIC->INTFLAG.reg = 0x1 << 4 ;
	}

	/*********************************************************************** EIC ch 5 int handler ***********************************************/

	if (EIC->INTFLAG.reg & 0x1 << 5)
	{
		EIC->INTFLAG.reg = 0x1 << 5 ;
	}

	/*********************************************************************** EIC ch 6 int handler ***********************************************/

	if (EIC->INTFLAG.reg & 0x1 << 6)
	{
		EIC->INTFLAG.reg = 0x1 << 6 ;
	}

	/*********************************************************************** EIC ch 7 int handler ***********************************************/

	if (EIC->INTFLAG.reg & 0x1 << 7)
	{
		EIC->INTFLAG.reg = 0x1 << 7 ;
	}

	/*********************************************************************** EIC ch 8 int handler ***********************************************/

	if (EIC->INTFLAG.reg & 0x1 << 8)
	{
		EIC->INTFLAG.reg = 0x1 << 8 ;
	}

	/*********************************************************************** ch 9 ********************************************************************/

	if (EIC->INTFLAG.reg & 0x1 << 9)
	{
		EIC->INTFLAG.reg = 0x1 << 9 ;
	}

	/*********************************************************************** ch 10 ********************************************************************/

	if (EIC->INTFLAG.reg & 0x1 << 10)
	{
		
		EIC->INTFLAG.reg = 0x1 << 10 ;
	}

	/*********************************************************************** ch 11 ********************************************************************/

	if (EIC->INTFLAG.reg & 0x1 << 11)
	{
		
		EIC->INTFLAG.reg = 0x1 << 11 ;
	}

	/*********************************************************************** ch 12 ********************************************************************/

	if (EIC->INTFLAG.reg & 0x1 << 12)
	{
		EIC->INTFLAG.reg = 0x1 << 12 ;
	}

	/*********************************************************************** ch 13 ********************************************************************/

	if (EIC->INTFLAG.reg & 0x1 << 13)
	{
		EIC->INTFLAG.reg = 0x1 << 13 ;
	}

	/*********************************************************************** ch 14 ********************************************************************/

	if (EIC->INTFLAG.reg & 0x1 << 14)
	{
		EIC->INTFLAG.reg = 0x1 << 14 ;
	}

	/*********************************************************************** ch 15 ********************************************************************/

	if (EIC->INTFLAG.reg & 0x1 << 15)
	{
		EIC->INTFLAG.reg = 0x1 << 15 ;
	}
}

