/*
 * port_defs.h
 *
 * Created: 16/06/2023 09:22:57
 *  Author: Simon
 */ 


#ifndef PORT_DEFS_H_
#define PORT_DEFS_H_


#include <inttypes.h>


// PMUXO Peripheral pin multiplexing

typedef enum
{
	Digital_input = 0xF0 ,
	Digital_output = 0xF1 ,
	EIC_input = 0x0 ,
	Event_input = 0x0 ,
	Analogue = 0x01 ,
	Sercom_pin = 0x02 ,
	Sercom_alt_pin = 0x03 ,
	TC_pin = 0x4 ,
	TCC_pin = 0x4 ,
	TCC_alt_pin = 0x5 ,
	CANbus_pin = 0x6 ,
	Comparator_pin = 0x7 ,
	GCLK_pin = 0x7
		
} port_pin_functions_t;
	
typedef enum
{
 PA00 = 0b00000000 ,
 PA01 = 0b00000001 ,
 PA02 = 0b00000010 ,
 PA03 = 0b00000011 ,
 PA04 = 0b00000100 ,
 PA05 = 0b00000101 ,
 PA06 = 0b00000110 ,
 PA07 = 0b00000111 ,
 PA08 = 0b00001000 ,
 PA09 = 0b00001001 ,
 PA10 = 0b00001010 ,
 PA11 = 0b00001011 ,
 PA12 = 0b00001100 ,
 PA13 = 0b00001101 ,
 PA14 = 0b00001110 ,
 PA15 = 0b00001111 ,
 PA16 = (0x0 + 16) ,
 PA17 = (0x0 + 17) ,
 PA18 = (0x0 + 18) ,
 PA19 = (0x0 + 19) ,
 PA20 = (0x0 + 20) ,
 PA21 = (0x0 + 21) ,
 PA22 = (0x0 + 22) ,
 PA23 = (0x0 + 23) ,
 PA24 = (0x0 + 24) ,
 PA25 = (0x0 + 25) ,
 PA26 = (0x0 + 26) ,
 PA27 = (0x0 + 27) ,
 PA28 = (0x0 + 28) ,
 PA29 = (0x0 + 29) ,
 PA30 = (0x0 + 30) ,
 PA31 = (0x0 + 31) ,

 PB00 = ((0x1 << 5) + 0) ,
 PB01 = ((0x1 << 5) + 1) ,
 PB02 = ((0x1 << 5) + 2) ,
 PB03 = ((0x1 << 5) + 3) ,
 PB04 = ((0x1 << 5) + 4) ,
 PB05 = ((0x1 << 5) + 5) ,
 PB06 = ((0x1 << 5) + 6) ,
 PB07 = ((0x1 << 5) + 7) ,
 PB08 = ((0x1 << 5) + 8) ,
 PB09 = ((0x1 << 5) + 9) ,
 PB10 = ((0x1 << 5) + 10) ,
 PB11 = ((0x1 << 5) + 11) ,
 PB12 = ((0x1 << 5) + 12) ,
 PB13 = ((0x1 << 5) + 13) ,
 PB14 = ((0x1 << 5) + 14) ,
 PB15 = ((0x1 << 5) + 15) ,
 PB16 = ((0x1 << 5) + 16) ,
 PB17 = ((0x1 << 5) + 17) ,
 PB18 = ((0x1 << 5) + 18) ,
 PB19 = ((0x1 << 5) + 19) ,
 PB20 = ((0x1 << 5) + 20) ,
 PB21 = ((0x1 << 5) + 21) ,
 PB22 = ((0x1 << 5) + 22) ,
 PB23 = ((0x1 << 5) + 23) ,
 PB24 = ((0x1 << 5) + 24) ,
 PB25 = ((0x1 << 5) + 25) ,
 PB26 = ((0x1 << 5) + 26) ,
 PB27 = ((0x1 << 5) + 27) ,
 PB28 = ((0x1 << 5) + 28) ,
 PB29 = ((0x1 << 5) + 29) ,
 PB30 = ((0x1 << 5) + 30) ,
 PB31 = ((0x1 << 5) + 31)
	
	} pin_t;
	
	

// Register locations & offsets
#define PORTS_BASE   0x41000000UL
#define PORTn_offset 0x80

#define PORTn_DIR    0x00
#define PORTn_DIRCLR 0x04
#define PORTn_DIRSET 0x08
#define PORTn_DIRTGL 0x0C
#define PORTn_OUT    0x10
#define PORTn_OUTSET 0x18
#define PORTn_OUTCLR 0x14
#define PORTn_OUTTGL 0x1C
#define PORTn_IN     0x20
#define PORTn_PMUX   0x30
#define PORTn_PINCFG 0x40

#define PORTB 0x1

#define PinNumberMask  0b00011111 // this is used to "&" out the port number for use of just the pin number
#define PinNumOnlyMask 0b00011111 // this is used to "&" out the port number for use of just the pin number

#define PIN_MASK(x) (0x1 << (x & PinNumberMask))

#define PORT_DIR(n)    ( 0x00 + PORTS_BASE + PORTn_offset * ( n >> 5 ) )
#define PORT_DIRSET(n) ( 0x08 + PORTS_BASE + PORTn_offset * ( n >> 5 ) )
#define PORT_DIRCLR(n) ( 0x04 + PORTS_BASE + PORTn_offset * ( n >> 5 ) )
#define PORT_DIRTGL(n) ( 0x0C + PORTS_BASE + PORTn_offset * ( n >> 5 ) )
#define PORT_OUT(n)    ( 0x10 + PORTS_BASE + PORTn_offset * ( n >> 5 ) )
#define PORT_OUTSET(n) ( 0x18 + PORTS_BASE + PORTn_offset * ( n >> 5 ) )
#define PORT_OUTCLR(n) ( 0x14 + PORTS_BASE + PORTn_offset * ( n >> 5 ) )
#define PORT_OUTTGL(n) ( 0x1C + PORTS_BASE + PORTn_offset * ( n >> 5 ) )
#define PORT_IN(n)     ( 0x20 + PORTS_BASE + PORTn_offset * ( n >> 5 ) )
#define PORT_PMUX(n)   ( 0x30 + PORTS_BASE + PORTn_offset * ( n >> 5 ) + ( ( n & PinNumberMask ) >> 1 ) )
// pin number divided by 30 to extract port number, port number nulled out and pin number divided by 2 as each register has settings for 2 pins

#define PORT_PINCFG(n) ( 0x40 + PORTS_BASE + PORTn_offset * ( n >> 5 ) + ( n & PinNumberMask ) )



#endif /* PORT_DEFS_H_ */