/*
 * tc_pwm_8bit.c
 *
 * Created: 16/06/2023 13:20:36
 *  Author: Simon
 */ 

#include "system.h"
#include "samc21.h"

#include "tc_hal.h"

//static uint8_t TC_counter_allocation ;
//static uint16_t TC_channel_allocation ;

static uint16_t tc_period[5] ;

static uint8_t tc_n_return(Tc * n)
{
	uint8_t ret_v ;
	
	if (n == TC0) ret_v = 0 ;
	if (n == TC1) ret_v = 1 ;
	if (n == TC2) ret_v = 2 ;
	if (n == TC3) ret_v = 3 ;
	if (n == TC4) ret_v = 4 ;
	
	return ret_v ;
}


void tc_enable(Tc * instance)
{
	while (instance->COUNT8.SYNCBUSY.bit.ENABLE) { ; } instance->COUNT8.CTRLA.bit.ENABLE = 0x1 ;
}


void tc_disable(Tc * instance)
{
	while (instance->COUNT8.SYNCBUSY.bit.ENABLE){ ; } instance->COUNT8.CTRLA.bit.ENABLE = 0x0 ;
}


void tc_pwm_duty_update(Tc * instance, tc_ch_t channel,  percent_t duty)
{		
	if (tc_period[tc_n_return(instance)] > 0xFF) // check to see if the counter is being used in 16 bit mode
	{
		if ( (tc_n_return(instance) < 0xFFFF) && (channel == 0) ) // check to see if the channel to update is channel 0
		{
			while (1)
			{
				; // As the counter is in 16 bit mode with a custom period channel 0 cannot be used as it is the PER register
			}
		}
		instance->COUNT16.CC[channel].reg = (uint16_t) ((duty * tc_period[tc_n_return(instance)]) / 100 ) ;
		
		return ;
	}
	
	else instance->COUNT8.CC[channel].reg = (uint8_t) ( (duty * tc_period[tc_n_return(instance)]) / 100 ) ;
}


void tc_pwm_setup_enable(Tc * instance, uint16_t period, tc_prescaler_t prescaler)
{	
	tc_period[tc_n_return(instance)] = period ;
	
	instance->COUNT8.CTRLA.bit.MODE = 0x1 ;
	instance->COUNT8.CTRLA.bit.PRESCALER = prescaler ;
	instance->COUNT8.WAVE.bit.WAVEGEN = 0x2 ;
	instance->COUNT8.PER.reg = period ;
	
	while (instance->COUNT8.SYNCBUSY.bit.ENABLE) { ; } instance->COUNT8.CTRLA.bit.ENABLE = 0x1  ;
}