/*
 * tc_pwm_8bit.h
 *
 * Created: 16/06/2023 13:20:56
 *  Author: Simon
 */ 


#ifndef TC_PWM_8BIT_H_
#define TC_PWM_8BIT_H_

#include "system.h"

typedef enum {
	tc_prescaler_1 = 0x0,
	tc_prescaler_2 = 0x1,
	tc_prescaler_4 = 0x2,
	tc_prescaler_8 = 0x3,
	tc_prescaler_16 = 0x4,
	tc_prescaler_64 = 0x5,
	tc_prescaler_256 = 0x6,
	tc_prescaler_1024 = 0x7
	
} tc_prescaler_t ;

typedef enum
{
	tc_ch0 = 0x0 ,
	tc_ch1 = 0x1
	
} tc_ch_t;

// connect_peripheral_to_clock(per, ch)

extern void tc_disable(Tc * instance) ;

extern void tc_enable(Tc * instance) ; // Only use after counter has been disabled manually

extern void tc_pwm_setup_enable(Tc * instance, uint16_t period, tc_prescaler_t prescaler) ; // connect counter to clock first

extern void tc_pwm_duty_update(Tc * instance, tc_ch_t channel,  percent_t duty) ; // connect counter to clock first


#endif /* TC_PWM_8BIT_H_ */